#include "TimSynth.h"

void copy_buf8_to_buf16(signed char *buf, signed short *buf2)
{
	_asm
	// save FSR2
	MOVFF	FSR2L, fsr2l_save
	MOVFF	FSR2H, fsr2h_save
	
	//	set FSR0 to *buf
	MOVLW 0xfd
	MOVFF PLUSW2, FSR0L
	MOVLW 0xfe
	MOVFF PLUSW2, FSR0H

	// set FSR2 to *buf2
	MOVLW 0xfb
	MOVFF PLUSW2, tempchar
	MOVLW 0xfc
	MOVFF PLUSW2, FSR2H
	MOVFF tempchar, FSR2L
	
	//	bufcnt = 64;
	MOVLW BUFSIZE
	MOVWF bufcnt, ACCESS

AGAIN:
	MOVFF	INDF0, POSTINC2
	CLRF	INDF2, ACCESS
	BTFSC	POSTINC0, 7, ACCESS
	SETF	INDF2, ACCESS
	MOVF	POSTINC2, F, ACCESS
		
	DECFSZ	bufcnt, F, ACCESS
	BRA		AGAIN

	// restore FSR2
	MOVFF	fsr2l_save, FSR2L
	MOVFF	fsr2h_save, FSR2H

	_endasm	
}
