#include "TimSynth.h"

void copy_rombuf8dup_to_buf16(const rom signed char rom *buf, signed short *buf2)
{
	_asm
		//	set TBLPTR to *buf
		MOVLW 0xfd
		MOVFF PLUSW2, TBLPTRL
		MOVLW 0xfe
		MOVFF PLUSW2, TBLPTRH
		
		//	set FSR0 to *buf2
		MOVLW 0xfb
		MOVFF PLUSW2, FSR0L
		MOVLW 0xfc
		MOVFF PLUSW2, FSR0H
		
		//	bufcnt = BUFSIZE;
		MOVLW BUFSIZE/4
		MOVWF bufcnt, ACCESS

AGAIN:
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		MOVLW	0x00
		BTFSC	TABLAT, 7, ACCESS
		MOVLW	0xFF
		MOVWF	POSTINC0, ACCESS
		MOVFF	TABLAT, POSTINC0
		MOVWF	POSTINC0, ACCESS

		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		MOVLW	0x00
		BTFSC	TABLAT, 7, ACCESS
		MOVLW	0xFF
		MOVWF	POSTINC0, ACCESS
		MOVFF	TABLAT, POSTINC0
		MOVWF	POSTINC0, ACCESS

		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		MOVLW	0x00
		BTFSC	TABLAT, 7, ACCESS
		MOVLW	0xFF
		MOVWF	POSTINC0, ACCESS
		MOVFF	TABLAT, POSTINC0
		MOVWF	POSTINC0, ACCESS

		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		MOVLW	0x00
		BTFSC	TABLAT, 7, ACCESS
		MOVLW	0xFF
		MOVWF	POSTINC0, ACCESS
		MOVFF	TABLAT, POSTINC0
		MOVWF	POSTINC0, ACCESS


		DECFSZ	bufcnt, F, ACCESS
		BRA		AGAIN
	_endasm
}
