#include "TimSynth.h"

void copy_rombuf8dup_to_buf8(const rom signed char rom *buf, signed char *buf2)
{
	_asm
		//	set TBLPTR to *buf
		MOVLW 0xfd
		MOVFF PLUSW2, TBLPTRL
		MOVLW 0xfe
		MOVFF PLUSW2, TBLPTRH
		
		//	set FSR0 to *buf2
		MOVLW 0xfb
		MOVFF PLUSW2, FSR0L
		MOVLW 0xfc
		MOVFF PLUSW2, FSR0H

		//	bufcnt = BUFSIZE;
		MOVLW BUFSIZE/16
		MOVWF bufcnt, ACCESS

		// unloop for 16-sample blocks
AGAIN:
		TBLRDPOSTINC
		MOVF	TABLAT, W, ACCESS
		MOVWF	POSTINC0, ACCESS
		MOVWF	POSTINC0, ACCESS
		TBLRDPOSTINC
		MOVF	TABLAT, W, ACCESS
		MOVWF	POSTINC0, ACCESS
		MOVWF	POSTINC0, ACCESS
		TBLRDPOSTINC
		MOVF	TABLAT, W, ACCESS
		MOVWF	POSTINC0, ACCESS
		MOVWF	POSTINC0, ACCESS
		TBLRDPOSTINC
		MOVF	TABLAT, W, ACCESS
		MOVWF	POSTINC0, ACCESS
		MOVWF	POSTINC0, ACCESS
		TBLRDPOSTINC
		MOVF	TABLAT, W, ACCESS
		MOVWF	POSTINC0, ACCESS
		MOVWF	POSTINC0, ACCESS
		TBLRDPOSTINC
		MOVF	TABLAT, W, ACCESS
		MOVWF	POSTINC0, ACCESS
		MOVWF	POSTINC0, ACCESS
		TBLRDPOSTINC
		MOVF	TABLAT, W, ACCESS
		MOVWF	POSTINC0, ACCESS
		MOVWF	POSTINC0, ACCESS
		TBLRDPOSTINC
		MOVF	TABLAT, W, ACCESS
		MOVWF	POSTINC0, ACCESS
		MOVWF	POSTINC0, ACCESS

		DECFSZ	bufcnt, F, ACCESS
		BRA		AGAIN
	_endasm
}
