#include "TimSynth.h"

void xor_buf8_by_buf8(signed char *buf, signed char *buf2)
{
	_asm
		// save FSR2
		MOVFF	FSR2L, fsr2l_save
		MOVFF	FSR2H, fsr2h_save
		
		//	set FSR0 to *buf
		MOVLW 0xfd
		MOVFF PLUSW2, FSR0L
		MOVLW 0xfe
		MOVFF PLUSW2, FSR0H
	
		//	set FSR2 to *buf2
		MOVLW 0xfb
		MOVFF PLUSW2, tempchar
		MOVLW 0xfc
		MOVFF PLUSW2, FSR2H
		MOVFF tempchar, FSR2L
	
		//	bufcnt = 64;
		MOVLW BUFSIZE/16
		MOVWF bufcnt, ACCESS

AGAIN:
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS
		MOVF	POSTINC2, W, ACCESS
		XORWF	POSTINC0, F, ACCESS

		DECFSZ bufcnt, F, ACCESS
		BRA AGAIN

		// restore FSR2
		MOVFF	fsr2l_save, FSR2L
		MOVFF	fsr2h_save, FSR2H
		
	_endasm
}
