#ifndef BUTTON_H
#define BUTTON_H

#define BUTTON_1	button.bits.button1
#define BUTTON_2	button.bits.button2
#define BUTTON_3	button.bits.button3
#define BUTTON_4	button.bits.button4
#define BUTTON_5	button.bits.button5
#define BUTTON_6	button.bits.button6
#define BUTTON_7	button.bits.button7
#define BUTTON_8	button.bits.button8
#define BUTTON_M	button.bits.buttonM
#define BUTTONS		button.bits.raw
#define BUTTONS_B	button.bits.buttons
#define BUTTONS_E	button.bits.muttons

#define CLICKED_1	button_clicked.bits.button1
#define CLICKED_2	button_clicked.bits.button2
#define CLICKED_3	button_clicked.bits.button3
#define CLICKED_4	button_clicked.bits.button4
#define CLICKED_5	button_clicked.bits.button5
#define CLICKED_6	button_clicked.bits.button6
#define CLICKED_7	button_clicked.bits.button7
#define CLICKED_8	button_clicked.bits.button8
#define CLICKED_M	button_clicked.bits.muttonM
#define CLICKED		button_clicked.bits.raw
#define CLICKED_B	button_clicked.bits.buttons
#define CLICKED_E	button_clicked.bits.buttons

#define RELEASED_1	button_released.bits.button1
#define RELEASED_2	button_released.bits.button2
#define RELEASED_3	button_released.bits.button3
#define RELEASED_4	button_released.bits.button4
#define RELEASED_5	button_released.bits.button5
#define RELEASED_6	button_released.bits.button6
#define RELEASED_7	button_released.bits.button7
#define RELEASED_8	button_released.bits.button8
#define RELEASED_M	button_released.bits.muttonM
#define RELEASED	button_released.bits.raw
#define RELEASED_B	button_released.bits.buttons
#define RELEASED_E	button_released.bits.buttons


typedef union _buttonbits
{
	unsigned short raw;
	struct
	{
		unsigned char buttons;
		unsigned char muttons;
	};
	struct
	{
		unsigned char button1:1;
		unsigned char button2:1;
		unsigned char button3:1;
		unsigned char button4:1;
		unsigned char button5:1;
		unsigned char button6:1;
		unsigned char button7:1;
		unsigned char button8:1;
		unsigned char buttonM:1;
		unsigned char buttonN:1;
		unsigned char buttonO:1;
		unsigned char buttonP:1;
		unsigned char buttonQ:1;
		unsigned char buttonR:1;
		unsigned char buttonS:1;
		unsigned char buttonT:1;
	};
};


typedef union _btn
{
	union _buttonbits bits;
};

extern near union _btn button;
extern near union _btn button_clicked;
extern near union _btn button_released;

void button_init(void);

#endif
