#include "TimSynth.h"

MODULE_IMPL(mod_tempo_adjust)


void mod_tempo_adjust_init(void)
{
	led_config = SHOW_BUTTON_LED | SHOW_DIM_LED | SHOW_MED_LED | SHOW_BRIGHT_LED | SHOW_STEP_MED | SHOW_BAR_DIM;
	dim_led = 0;
	med_led = 0;
	bright_led = 0;
}

void mod_tempo_adjust_run(void)
{
	HANDLE_EXIT(0);

	dim_led = 0x00;
	med_led = 0x00;
	bright_led = 0x00;

	if(new_step & 0x01)
	{
		new_step ^= 0x01;
		EXTRA_LED1 = 1;
	}
	else
	{
		EXTRA_LED1 = 0;
	}

	if(new_step & 0x02)
	{
		new_step ^= 0x02;
		EXTRA_LED2 = 1;
	}
	else
	{
		EXTRA_LED2 = 0;
	}

	if(CLICKED_B)
	{
		if(BUTTON_M)
		{
			if(CLICKED_1)
			{
				seqtiming_restart(24000);
			}
			if(CLICKED_2)
			{
				seqtiming_restart(12000);
			}
			if(CLICKED_3)
			{
				seqtiming_restart( 6000);
			}
			if(CLICKED_4)
			{
				seqtiming_restart( 3000);
			}
			if(CLICKED_5)
			{
				seqtiming_restart( 1500);
			}
			if(CLICKED_6)
			{
				seqtiming_restart(  750);
			}
			if(CLICKED_7)
			{
				seqtiming_restart(  375);
			}
		}
		else
		{	
			if(CLICKED_1)
			{
				seqtiming_slower(1000);
			}
			else if(CLICKED_2)
			{
				seqtiming_slower(100);
			}
			else if(CLICKED_3)
			{
				seqtiming_slower(10);
			}
			else if(CLICKED_4)
			{
				seqtiming_faster(10);
			}
			else if(CLICKED_5)
			{
				seqtiming_faster(100);
			}
			else if(CLICKED_6)
			{
				seqtiming_faster(1000);
			}
			else if(CLICKED_7)
			{
				seqtiming_restart(1);
			}				
		}
	}
}

void mod_tempo_adjust_exit(void)
{
}
