#ifndef TIMSYNTH_H
#define TIMSYNTH_H

#include <p18cxxx.h>

#include "mytypes.h"
#include "pindef.h"
#include "hardware.h"
#include "irq.h"
#include "sysconfig.h"
#include "systimer.h"

#include "button.h"
#include "led.h"

#include "module.h"
#include "module_handler.h"
#include "user_modules.h"
#include "render_modules.h"

#include "audio_core.h"
#include "audio_kernels.h"
#include "audio_buffers.h"
#include "audio_renderchain.h"
#include "samples.h"

#include "sound_generators.h"

#include "seqtiming.h"

#endif
