#include "TimSynth.h"

void add_buf8_to_buf16(signed char *buf, signed short *buf2)
{
	_asm
	// save FSR2
	MOVFF	FSR2L, fsr2l_save
	MOVFF	FSR2H, fsr2h_save
	
	//	set FSR0 to *buf
	MOVLW 0xfd
	MOVFF PLUSW2, FSR0L
	MOVLW 0xfe
	MOVFF PLUSW2, FSR0H

	//	set FSR2 to *buf2
	MOVLW 0xfb
	MOVFF PLUSW2, tempchar
	MOVLW 0xfc
	MOVFF PLUSW2, FSR2H
	MOVFF tempchar, FSR2L
	
	//	bufcnt = 64;
	MOVLW BUFSIZE/4
	MOVWF bufcnt, ACCESS

AGAIN:

	MOVF	INDF0, W, ACCESS
	ADDWF	POSTINC2, F, ACCESS
	
	MOVLW	0x00
	BTFSC	POSTINC0, 7, ACCESS
	MOVLW	0xFF
	ADDWFC	POSTINC2, F, ACCESS

	MOVF	INDF0, W, ACCESS
	ADDWF	POSTINC2, F, ACCESS
	
	MOVLW	0x00
	BTFSC	POSTINC0, 7, ACCESS
	MOVLW	0xFF
	ADDWFC	POSTINC2, F, ACCESS

	MOVF	INDF0, W, ACCESS
	ADDWF	POSTINC2, F, ACCESS
	
	MOVLW	0x00
	BTFSC	POSTINC0, 7, ACCESS
	MOVLW	0xFF
	ADDWFC	POSTINC2, F, ACCESS

	MOVF	INDF0, W, ACCESS
	ADDWF	POSTINC2, F, ACCESS
	
	MOVLW	0x00
	BTFSC	POSTINC0, 7, ACCESS
	MOVLW	0xFF
	ADDWFC	POSTINC2, F, ACCESS


	DECFSZ	bufcnt, F, ACCESS
	BRA		AGAIN

	// restore FSR2
	MOVFF	fsr2l_save, FSR2L
	MOVFF	fsr2h_save, FSR2H
	
	_endasm
}
