#include "TimSynth.h"

void buf8_volume_by_buf8(signed char *buf, signed char *buf2)
{
	_asm
		// save FSR2
		MOVFF	FSR2L, fsr2l_save
		MOVFF	FSR2H, fsr2h_save
		
		//	set FSR0 to *buf
		MOVLW 0xfd
		MOVFF PLUSW2, FSR0L
		MOVLW 0xfe
		MOVFF PLUSW2, FSR0H
	
		//	set FSR2 to *buf2
		MOVLW 0xfb
		MOVFF PLUSW2, tempchar
		MOVLW 0xfc
		MOVFF PLUSW2, FSR2H
		MOVFF tempchar, FSR2L
	
		//	bufcnt = 64;
		MOVLW BUFSIZE/4
		MOVWF bufcnt, ACCESS

		//	load vol parameter into WREG
		MOVLW 0xfc
		MOVFF PLUSW2, cval

AGAIN:
		MOVF	INDF0, W, ACCESS
		MOVWF	tempshort, ACCESS
		CLRF	tempshort+1, ACCESS
		BTFSC	tempshort, 7, ACCESS
		SETF	tempshort+1, ACCESS
		
		MOVF	POSTINC2, W, ACCESS
		MULWF	tempshort+1, ACCESS
		MOVFF	PRODL, tempshort+1
		MULWF	tempshort, ACCESS
		MOVFF	PRODL, tempshort
		MOVF	PRODH, W, ACCESS
		ADDWF	tempshort+1, W, ACCESS
		MOVWF	POSTINC0, ACCESS


		MOVF	INDF0, W, ACCESS
		MOVWF	tempshort, ACCESS
		CLRF	tempshort+1, ACCESS
		BTFSC	tempshort, 7, ACCESS
		SETF	tempshort+1, ACCESS
		
		MOVF	POSTINC2, W, ACCESS
		MULWF	tempshort+1, ACCESS
		MOVFF	PRODL, tempshort+1
		MULWF	tempshort, ACCESS
		MOVFF	PRODL, tempshort
		MOVF	PRODH, W, ACCESS
		ADDWF	tempshort+1, W, ACCESS
		MOVWF	POSTINC0, ACCESS


		MOVF	INDF0, W, ACCESS
		MOVWF	tempshort, ACCESS
		CLRF	tempshort+1, ACCESS
		BTFSC	tempshort, 7, ACCESS
		SETF	tempshort+1, ACCESS
		
		MOVF	POSTINC2, W, ACCESS
		MULWF	tempshort+1, ACCESS
		MOVFF	PRODL, tempshort+1
		MULWF	tempshort, ACCESS
		MOVFF	PRODL, tempshort
		MOVF	PRODH, W, ACCESS
		ADDWF	tempshort+1, W, ACCESS
		MOVWF	POSTINC0, ACCESS


		MOVF	INDF0, W, ACCESS
		MOVWF	tempshort, ACCESS
		CLRF	tempshort+1, ACCESS
		BTFSC	tempshort, 7, ACCESS
		SETF	tempshort+1, ACCESS
		
		MOVF	POSTINC2, W, ACCESS
		MULWF	tempshort+1, ACCESS
		MOVFF	PRODL, tempshort+1
		MULWF	tempshort, ACCESS
		MOVFF	PRODL, tempshort
		MOVF	PRODH, W, ACCESS
		ADDWF	tempshort+1, W, ACCESS
		MOVWF	POSTINC0, ACCESS

		DECFSZ bufcnt, F, ACCESS
		BRA AGAIN

		// restore FSR2
		MOVFF	fsr2l_save, FSR2L
		MOVFF	fsr2h_save, FSR2H
		
	_endasm
}
