#include "TimSynth.h"

void copy_rombuf8_to_buf8(const rom signed char rom *buf, signed char *buf2)
{
	_asm
		//	set TBLPTR to *buf
		MOVLW 0xfd
		MOVFF PLUSW2, TBLPTRL
		MOVLW 0xfe
		MOVFF PLUSW2, TBLPTRH
		
		//	set FSR0 to *buf2
		MOVLW 0xfb
		MOVFF PLUSW2, FSR0L
		MOVLW 0xfc
		MOVFF PLUSW2, FSR0H
		
		//	bufcnt = BUFSIZE;
		MOVLW BUFSIZE/16
		MOVWF bufcnt, ACCESS

AGAIN:
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0
		TBLRDPOSTINC
		MOVFF	TABLAT, POSTINC0

		DECFSZ	bufcnt, F, ACCESS
		BRA		AGAIN
	_endasm
}
