#ifndef AUDIO_RENDERCHAIN_H
#define AUDIO_RENDERCHAIN_H

#include "mytypes.h"

#define START_WITH_ADC			0x01
#define START_WITH_EMPTY		0x00
#define FINAL_VOLUME_ADJUST		0x02
#define NO_FINAL_VOLUME_ADJUST	0x00
#define FINAL_TO_DAC			0x04
#define FINAL_NOT_TO_DAC		0x00

void audio_renderchain_init(unsigned char cfg, unsigned char volume);
void audio_renderchain_set_volume(unsigned char volume);
void audio_renderchain_set_config(unsigned char cfg);
void audio_renderchain_clear(void);
void audio_renderchain_put(unsigned char slot, func *cfunc);
void audio_renderchain_remove(unsigned char slot);
void audio_renderchain_run(void);

#endif
