#ifndef SAMPLES_H
#define SAMPLES_H

#define HALF_SR		0x01
#define FULL_SR		0x00

typedef struct _smpl
{
	unsigned char sample_type;
	unsigned char num_blocks;
	signed char sample_data[];
};

extern const rom struct _smpl rom bassdrum;
extern const rom struct _smpl rom hitom;
extern const rom struct _smpl rom midtom;
extern const rom struct _smpl rom lowtom;
extern const rom struct _smpl rom snare;
extern const rom struct _smpl rom rimshot;
extern const rom struct _smpl rom openhat;
extern const rom struct _smpl rom closedhat;

void samples_init(void);

#endif
