#include "TimSynth.h"

#pragma udata

void main(void)
{	
	hardware_init();
	audio_core_init();
	samples_init();
	drumsynth_init();
	led_init();
	button_init();
	seqtiming_init(6000);
	module_handler_init();
	audio_renderchain_init(START_WITH_ADC | FINAL_VOLUME_ADJUST | FINAL_TO_DAC, 120);
	irq_init();
		
LOOP:	

	if(DO_COREBUF)
	{
		(cur_module_func)();

		audio_renderchain_run();

		CLICKED = 0;
		RELEASED = 0;
	}

	_asm 
		BCF		ASM_SEL2
		SLEEP 
	_endasm

	goto LOOP;
}
