#ifndef PINDEF_H
#define PINDEF_H

#define LED1	LATBbits.LATB4
#define LED2	LATBbits.LATB3

#define ASM_LED1	LATB, 4, ACCESS
#define ASM_LED2	LATB, 3, ACCESS

#define B1		PORTAbits.RA3
#define B2		PORTAbits.RA4
#define B3		PORTAbits.RA5
#define B4		PORTAbits.RA7
#define B5		PORTAbits.RA6
#define B6		PORTCbits.RC0
#define B7		PORTCbits.RC2
#define B8		PORTBbits.RB0
#define BM		PORTBbits.RB5

#define ASM_B1	PORTA, 3, ACCESS
#define ASM_B2	PORTA, 4, ACCESS
#define ASM_B3	PORTA, 5, ACCESS
#define ASM_B4	PORTA, 7, ACCESS
#define ASM_B5	PORTA, 6, ACCESS
#define ASM_B6	PORTC, 0, ACCESS
#define ASM_B7	PORTC, 2, ACCESS
#define ASM_B8	PORTB, 0, ACCESS
#define ASM_BM	PORTB, 5, ACCESS

#define SYNC_A_IN	PORTBbits.RB1
#define SYNC_B_IN	PORTBbits.RB2

#define SYNC_A_OUT	LATBbits.LATB1
#define SYNC_B_OUT	LATBbits.LATB2

#define SCK		LATCbits.LATC3
#define SDI		LATCbits.LATC4
#define SDO		LATCbits.LATC5

#define SEL1	LATCbits.LATC6
#define SEL2	LATCbits.LATC7

#define ASM_SEL1	LATC, 6, ACCESS
#define ASM_SEL2	LATC, 7, ACCESS


#endif
