#include "TimSynth.h"

#pragma udata access led_data

near union _ledbits leds;

near unsigned char dim_led;
near unsigned char med_led;
near unsigned char bright_led;

near unsigned char moving_led;

near unsigned char led_cnt;

near unsigned char led_config;

//near unsigned char display_status;

#pragma udata

void led_init(void)
{
	PIR2bits.TMR3IF = 0;
	T3CON = 0b00000000;

	SEL1 = 1;

	led_reset();
}

void led_reset(void)
{
	led_config = 0x00;

	leds.raw = 0x00;

	dim_led = 0;
	med_led = 0;
	bright_led = 0;
	
	moving_led = 0;
	
	led_cnt = 0x00;
}
