#include "TimSynth.h"

MODULE_IMPL(mod_manual_drums)


void mod_manual_drums_init(void)
{
	led_config = SHOW_BRIGHT_LED | SHOW_MED_LED | SHOW_DIM_LED;
	dim_led = 0;
	med_led = 0;
	bright_led = 0;
	audio_renderchain_put(0, (func*)&render_drumsynth);

}

void mod_manual_drums_run(void)
{
	HANDLE_EXIT(1);

	if(CLICKED_B)
	{
		leds.raw = CLICKED_B;
		drumsynth_trigger(CLICKED_B);
		dim_led = drum_data.play.play_state;
	}
		
	dim_led = drum_data.play.play_state;
}

void mod_manual_drums_exit(void)
{
	audio_renderchain_remove(0);
}
